<?php declare(strict_types=1);

namespace Plugin\lfs_ts_features;

use JTL\Events\Dispatcher;
use JTL\Plugin\Bootstrapper;
use JTL\Smarty\JTLSmarty;

/**
 * Class Bootstrap
 * @package Plugin\lfs_ts_features
 */
class Bootstrap extends Bootstrapper
{
    /**
     * @param Dispatcher $dispatcher
     */
    public function boot(Dispatcher $dispatcher)
    {
        parent::boot($dispatcher);

        $dispatcher->listen('shop.hook.' . \HOOK_BESTELLABSCHLUSS_INC_BESTELLUNGINDB, function ($args) {
            $this->hook75($args);
        });

        $dispatcher->listen('shop.hook.' . \HOOK_LETZTERINCLUDE_INC, function ($args) {
            $this->hook99();
        });

        $dispatcher->listen('shop.hook.' . \HOOK_SMARTY_OUTPUTFILTER, function ($args) {
            $this->hook140();
        });
    }

    public function hook75($args_arr)
    {
        $_SESSION['lfs_kWarenkorb_TS'] = $args_arr['oBestellung']->kWarenkorb;
        $_SESSION['lfs_kKunde_TS'] = $args_arr['oBestellung']->kKunde;
    }

    public function hook99()
    {
        include_once $this->getPlugin()->getPaths()->getBasePath()."/hooks/99.php";
    }

    public function hook140()
    {
        include_once $this->getPlugin()->getPaths()->getBasePath()."/hooks/140.php";
    }

    public function renderAdminMenuTab(string $tabName, int $menuID, JTLSmarty $smarty): string
    {
        return parent::renderAdminMenuTab($tabName, $menuID, $smarty); // TODO: Change the autogenerated stub
    }
}