<?php declare(strict_types=1);

namespace Plugin\lfs_ts_features\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;

class Migration20190621100000 extends Migration implements IMigration
{
    public function up()
    {
        $this->execute("CREATE TABLE IF NOT EXISTS `xplugin_lfs_ts_features_config` (
                              `ts_id` varchar(50) NOT NULL,
                              `ts_sprache` int(2) DEFAULT '0',
                              `ts_modus` char(1) DEFAULT 'S',
                              `ts_BadgeVariante` char(10) DEFAULT 'reviews',
                              `ts_BadgeYOffset` int DEFAULT '0',
                              `ts_BadgeCode` varchar(2000) DEFAULT NULL,
                              `ts_ProduktBewertungAktiv` tinyint(1) DEFAULT '0',
                              `ts_ProduktBewertungRegisterAktiv` tinyint(1) DEFAULT '0',
                              `ts_ProduktBewertungRegisterNameTab` varchar(50) DEFAULT 'Trusted Shops Bewertungen',
                              `ts_ProduktBewertungRegisterRahmenfarbe` varchar(10) DEFAULT '#0DBEDC',
                              `ts_ProduktBewertungRegisterSternfarbe` varchar(10) DEFAULT '#ffdc0f',
                              `ts_ProduktBewertungRegisterSterngroesse` tinyint(10) DEFAULT '14',
                              `ts_ProduktBewertungRegisterLeer` tinyint(1) DEFAULT '0',
                              `ts_ProduktBewertungRegisterCode` varchar(2000) DEFAULT NULL,
                              `ts_ProduktBewertungRegisterSelector` varchar(100) DEFAULT '#product-tabs',
                              `ts_ProduktBewertungRegisterMethode` varchar(25) DEFAULT 'append',
                              `ts_ProduktBewertungSterneAktiv` varchar(10) DEFAULT '0',
                              `ts_ProduktBewertungSterneSternfarbe` varchar(10) DEFAULT '#ffdc0f',
                              `ts_ProduktBewertungSterneSterngroesse` tinyint(10) DEFAULT '15',
                              `ts_ProduktBewertungSterneSchriftgroesse` tinyint(10) DEFAULT '12',
                              `ts_ProduktBewertungSterneLeer` tinyint(1) DEFAULT '0',
                              `ts_ProduktBewertungSterneCode` varchar(2000) DEFAULT NULL,
                              `ts_ProduktBewertungSterneSelector` varchar(100) DEFAULT '.product-headline',
                              `ts_ProduktBewertungSterneMethode` varchar(25) DEFAULT 'after',
                              `ts_RatingWidgetAktiv` tinyint(1) DEFAULT '0',
                              `ts_RatingWidgetPosition` int(1) DEFAULT '0',
                              `ts_ReviewStickerAktiv` tinyint(1) DEFAULT '0',
                              `ts_ReviewStickerModus` varchar(25) DEFAULT 'testimonials',
                              `ts_ReviewStickerPosition` int(1) DEFAULT '1',
                              `ts_ReviewStickerSchriftart` varchar(25) DEFAULT 'Arial',
                              `ts_ReviewStickerBewertungsanzahl` varchar(25) DEFAULT '5',
                              `ts_ReviewStickerMindestnote` varchar(25) DEFAULT '3.0',
                              `ts_ReviewStickerHintergrundfarbe` varchar(10) DEFAULT '#ffdc0f',
                              `ts_ReviewStickerCode` varchar(2000) DEFAULT NULL,
                              `bTS_ProductStickerShow` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Anzeigeoption TS-ProductSticker (0=nein, 1=ja)',
                              `iTS_ProductStickerArt` int(1) NOT NULL DEFAULT '0' COMMENT 'Anzeigeart Product-Sticker (1=Anzeige Standard-Artikel,Vater-Artikel und Kind-Artikel, 2=Anzeige Standard-Artikel und Kind-Anzeige)'
                            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;");

        $this->execute("ALTER TABLE `xplugin_lfs_ts_features_config`
                              ADD PRIMARY KEY (`ts_id`),
                              ADD UNIQUE KEY `UNIQUE_KEY_TSID` (`ts_id`),
                              ADD UNIQUE KEY `UNIQUE_KEY_SPRACHE` (`ts_sprache`);");
    }

    public function down()
    {
        $this->execute("DROP TABLE IF EXISTS `xplugin_lfs_ts_features_config`");
    }
}