<?php
namespace Plugin\lfs_ts_features;

use JTL\Boxes\Admin\BoxAdmin;
use JTL\Plugin\Helper;
use JTL\Shop;

global $oPlugin;

include_once($oPlugin->getPaths()->getAdminPath() . 'inc/lfs_ts_features_predefine.php');

$smarty = Shop::Smarty();
$db = Shop::Container()->getDB();

unset($_SESSION['ts_features_error_add']);

$smarty->assign('ts_message', '');
$smarty->assign('ts_message_class', '');
$smarty->assign('backend_language', $_SESSION['AdminAccount']->language);

/** Initialisierung - Standardwerte für Trusted Shop CLASSIC - Einstellungen aus Core neutralisieren */
$ts_init_template_default = new \stdClass();
$ts_init_template_default->cWert = "N";

$db->updateRow("ttemplateeinstellungen", "cName", "show_trustbadge", $ts_init_template_default);

$sql = "SELECT cTSID FROM ttrustedshopszertifikat WHERE eType = 'CLASSIC'";
$ts_init_TSID_classic_arr = $db->executeQuery($sql, 2);

if (count($ts_init_TSID_classic_arr) > 0) {
    foreach ($ts_init_TSID_classic_arr as $ts_init_TSID_classic) {
        $db->deleteRow("ttrustedshopskundenbewertung", "cTSID", $ts_init_TSID_classic->cTSID, $echo = 0);
        $db->deleteRow("ttrustedshopsstatistik", "cTSID", $ts_init_TSID_classic->cTSID, $echo = 0);
        $db->deleteRow("ttrustedshopszertifikat", "cTSID", $ts_init_TSID_classic->cTSID, $echo = 0);
    }
}
/**/

function lfs_myFilterXSS($value)
{
    if(Shop::Smarty()->escape_html) { // vorbereitend für Shop 5
        return $value;
    }
    return htmlspecialchars($value, ENT_QUOTES, JTL_CHARSET);
}

if ($_SERVER['REQUEST_METHOD'] == 'POST' && $_POST["jtl_token"] === $_SESSION['jtl_token']) {
    if (isset($_POST['ts_id']) && $db->realEscape($_POST['ts_id']) != "" && isset($_POST['ts_id_is_add']) && (int)$_POST['ts_id_is_add'] == 1) {
        $ts_id_add = new \stdClass();
        $ts_id_add->ts_id = $db->realEscape($_POST['ts_id']);
        $ts_id_add->ts_sprache = $db->realEscape($_POST['ts_sprache']);

        $queryResult = 0;
        if ($ts_id_add->ts_sprache != 0) {
            /** Pre-Define Badge-Code **/
            $ts_BadgeCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_BadgeCode_pre.tpl", true);
            $ts_BadgeCode = str_replace("##ts_id##", $ts_id_add->ts_id, $ts_BadgeCode);
            $ts_id_add->ts_BadgeCode = $ts_BadgeCode;

            /** Pre-Define ProduktBewertungRegister-Code **/
            $ts_ProduktBewertungRegisterCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ProduktBewertungRegisterCode_pre.tpl", true);
            $ts_ProduktBewertungRegisterCode = str_replace("##ts_id##", $ts_id_add->ts_id, $ts_ProduktBewertungRegisterCode);
            $ts_id_add->ts_ProduktBewertungRegisterCode = $ts_ProduktBewertungRegisterCode;

            /** Pre-Define ProduktBewertungSterne-Code **/
            $ts_ProduktBewertungSterneCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ProduktBewertungSterneCode_pre.tpl", true);
            $ts_ProduktBewertungSterneCode = str_replace("##ts_id##", $ts_id_add->ts_id, $ts_ProduktBewertungSterneCode);
            $ts_id_add->ts_ProduktBewertungSterneCode = $ts_ProduktBewertungSterneCode;

            /** Pre-Define ReviewSticker-Code **/
            $ts_ReviewStickerCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ReviewStickerCode_pre.tpl", true);
            $ts_ReviewStickerCode = str_replace("##ts_id##", $ts_id_add->ts_id, $ts_ReviewStickerCode);
            $ts_id_add->ts_ReviewStickerCode = $ts_ReviewStickerCode;

            $queryResult = $db->insertRow("xplugin_lfs_ts_features_config", $ts_id_add);
        }

        if ($queryResult == 1) {
            $_SESSION['ts_features_error_add'] = "0";
            $smarty->assign('ts_message', __('Die ID: ') . lfs_myFilterXSS($_POST['ts_id']) . ' ' . __('wurde angelegt!'));
            $smarty->assign('ts_message_class', 'box_success alert alert-success');
        } else {
            $_SESSION['ts_features_error_add'] = "1";
            $js_redirect = '<script type="text/javascript">';
            $js_redirect .= 'window.location = "' . Shop::getURL() . '/admin/plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Konfiguration&ts_add_error=1' . '"';
            $js_redirect .= '</script>';
            echo $js_redirect;
        }
    }

    if (isset($_POST['ts_id']) && $db->realEscape($_POST['ts_id']) != "" && isset($_POST['ts_id_is_delete']) && (int)$_POST['ts_id_is_delete'] == 1) {
        $queryResult = $db->deleteRow("xplugin_lfs_ts_features_config", "ts_id", $db->realEscape($_POST['ts_id']));

        if ($queryResult == 1) {
            $smarty->assign('ts_message', __('Die ID: ') . $db->realEscape($_POST['ts_id']) . ' ' . __('wurde gelöscht!'));
            $smarty->assign('ts_message_class', 'box_success alert alert-success');
        } else {
            $smarty->assign('ts_message', __('Es trat ein Fehler auf - ID konnte nicht gelöscht werden!'));
            $smarty->assign('ts_message_class', 'box_error alert alert-danger');
        }
    }

    if (isset($_POST['ts_id']) && $db->realEscape($_POST['ts_id']) != "" && isset($_POST['ts_id_options_cancel']) && (int)$_POST['ts_id_options_cancel'] == 1) {
        $smarty->assign('ts_message', __('Die Bearbeitung wurde abgebrochen - Änderungen wurden nicht gespeichert!'));
        $smarty->assign('ts_message_class', 'box_info alert alert-warning');
    }

    if (isset($_POST['ts_id']) && $db->realEscape($_POST['ts_id']) != "" && isset($_POST['ts_id_options_save']) && (int)$_POST['ts_id_options_save'] == 1) {
        $ts_id_edit = new \stdClass();
        $ts_id_edit->ts_id = $db->realEscape($_POST['ts_id']);
        $ts_id_edit->ts_sprache = (int)$_POST['ts_sprache'];

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            /** Pre-Define Badge-Code **/
            $ts_BadgeCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_BadgeCode_pre.tpl", true);
            $ts_BadgeCode = str_replace("##ts_id##", $db->realEscape($_POST['ts_id']), $ts_BadgeCode);
            $ts_id_edit->ts_BadgeCode = $ts_BadgeCode;
        }
        else {
            $ts_id_edit->ts_BadgeCode = lfs_myFilterXSS($_POST['ts_BadgeCode']);
        }

        $ts_id_edit->ts_RatingWidgetAktiv = (int)$_POST['ts_RatingWidgetAktiv'];
        $ts_id_edit->ts_RatingWidgetPosition = (int)$_POST['ts_RatingWidgetPosition'];
        $ts_id_edit->ts_ReviewStickerAktiv = (int)$_POST['ts_ReviewStickerAktiv'];
        $ts_id_edit->ts_ReviewStickerPosition = (int)$_POST['ts_ReviewStickerPosition'];

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            $ts_ReviewStickerCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ReviewStickerCode_pre.tpl", true);
            $ts_ReviewStickerCode = str_replace("##ts_id##", $db->realEscape($_POST['ts_id']), $ts_ReviewStickerCode);
            $ts_id_edit->ts_ReviewStickerCode = $ts_ReviewStickerCode;
        }
        else {
            $ts_id_edit->ts_ReviewStickerCode = lfs_myFilterXSS($_POST['ts_ReviewStickerCode']);
        }

        $ts_id_edit->ts_modus = $db->realEscape($_POST['ts_modus']);
        $ts_id_edit->ts_BadgeVariante = $db->realEscape($_POST['ts_BadgeVariante']);
        $ts_id_edit->ts_BadgeYOffset = $db->realEscape($_POST['ts_BadgeYOffset']);
        $ts_id_edit->ts_ProduktBewertungAktiv = $db->realEscape($_POST['ts_ProduktBewertungAktiv']);
        $ts_id_edit->ts_ProduktBewertungRegisterAktiv = $db->realEscape($_POST['ts_ProduktBewertungRegisterAktiv']);
        $ts_id_edit->ts_ProduktBewertungRegisterNameTab = $db->realEscape($_POST['ts_ProduktBewertungRegisterNameTab']);
        $ts_id_edit->ts_ProduktBewertungRegisterRahmenfarbe = $db->realEscape($_POST['ts_ProduktBewertungRegisterRahmenfarbe']);
        $ts_id_edit->ts_ProduktBewertungRegisterSternfarbe = $db->realEscape($_POST['ts_ProduktBewertungRegisterSternfarbe']);
        $ts_id_edit->ts_ProduktBewertungRegisterSterngroesse = $db->realEscape($_POST['ts_ProduktBewertungRegisterSterngroesse']);

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            /** Pre-Define ProduktBewertungRegister-Code **/
            $ts_ProduktBewertungRegisterCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ProduktBewertungRegisterCode_pre.tpl", true);
            $ts_ProduktBewertungRegisterCode = str_replace("##ts_id##", $db->realEscape($_POST['ts_id']), $ts_ProduktBewertungRegisterCode);
            $ts_id_edit->ts_ProduktBewertungRegisterCode = $ts_ProduktBewertungRegisterCode;
        }
        else {
            $ts_id_edit->ts_ProduktBewertungRegisterCode = lfs_myFilterXSS($_POST['ts_ProduktBewertungRegisterCode']);
        }

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            $ts_id_edit->ts_ProduktBewertungRegisterSelector = "#product-tabs";
        }
        else {
            $ts_id_edit->ts_ProduktBewertungRegisterSelector = $db->realEscape($_POST['ts_ProduktBewertungRegisterSelector']);
        }


        $ts_id_edit->ts_ProduktBewertungSterneAktiv = $db->realEscape($_POST['ts_ProduktBewertungSterneAktiv']);
        $ts_id_edit->ts_ProduktBewertungSterneSternfarbe = $db->realEscape($_POST['ts_ProduktBewertungSterneSternfarbe']);
        $ts_id_edit->ts_ProduktBewertungSterneSterngroesse = $db->realEscape($_POST['ts_ProduktBewertungSterneSterngroesse']);
        $ts_id_edit->ts_ProduktBewertungSterneSchriftgroesse = $db->realEscape($_POST['ts_ProduktBewertungSterneSchriftgroesse']);
        $ts_id_edit->ts_ProduktBewertungRegisterLeer = (isset($_POST['ts_ProduktBewertungRegisterLeer']))?1:0;
        $ts_id_edit->ts_ProduktBewertungSterneLeer = (isset($_POST['ts_ProduktBewertungSterneLeer']))?1:0;

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            /** Pre-Define ProduktBewertungSterne-Code **/
            $ts_ProduktBewertungSterneCode = file_get_contents($oPlugin->getPaths()->getAdminPath() . "template/tpl_inc/inc_ts_ProduktBewertungSterneCode_pre.tpl", true);
            $ts_ProduktBewertungSterneCode = str_replace("##ts_id##", $db->realEscape($_POST['ts_id']), $ts_ProduktBewertungSterneCode);
            $ts_id_edit->ts_ProduktBewertungSterneCode = $ts_ProduktBewertungSterneCode;
        }
        else {
            $ts_id_edit->ts_ProduktBewertungSterneCode = lfs_myFilterXSS($_POST['ts_ProduktBewertungSterneCode']);
        }

        if ($db->realEscape($_POST['ts_modus']) == "S") {
            $ts_id_edit->ts_ProduktBewertungSterneSelector = "#product-offer .info-essential";
        }
        else {
            $ts_id_edit->ts_ProduktBewertungSterneSelector = $db->realEscape($_POST['ts_ProduktBewertungSterneSelector']);
        }

        $ts_id_edit->ts_ReviewStickerModus = $db->realEscape($_POST['ts_ReviewStickerModus']);
        $ts_id_edit->ts_ReviewStickerSchriftart = $db->realEscape($_POST['ts_ReviewStickerSchriftart']);
        $ts_id_edit->ts_ReviewStickerBewertungsanzahl = $db->realEscape($_POST['ts_ReviewStickerBewertungsanzahl']);
        $ts_id_edit->ts_ReviewStickerMindestnote = $db->realEscape($_POST['ts_ReviewStickerMindestnote']);
        $ts_id_edit->ts_ReviewStickerHintergrundfarbe = $db->realEscape($_POST['ts_ReviewStickerHintergrundfarbe']);

        $oTSFeature_Box = new BoxAdmin($db);

        /** Boxensteuerung Review-Sticker **/
        $ts_check_box = $db->selectSingleRow('tboxen', 'cTitel', 'Trusted Shops - Reviews');
        $ts_check_box_vorlage = $db->selectSingleRow('tboxvorlage', 'cName', 'Trusted Shops - Reviews');

        if (is_object($ts_check_box))
            $oTSFeature_Box->delete($ts_check_box->kBox);

        if ((int)$ts_id_edit->ts_ReviewStickerPosition == 1 && (int)$ts_id_edit->ts_ReviewStickerAktiv == 1)
            $oTSFeature_Box->create($ts_check_box_vorlage->kBoxvorlage, 0, 'left');

        if ((int)$ts_id_edit->ts_ReviewStickerPosition == 2 && (int)$ts_id_edit->ts_ReviewStickerAktiv == 1)
            $oTSFeature_Box->create($ts_check_box_vorlage->kBoxvorlage, 0, 'right');

        if ((int)$ts_id_edit->ts_ReviewStickerPosition == 3 && (int)$ts_id_edit->ts_ReviewStickerAktiv == 1)
            $oTSFeature_Box->create($ts_check_box_vorlage->kBoxvorlage, 0, 'bottom');
        /**/

        /** Boxensteuerung Rating-Widget (deprecated)**/
        $ts_check_box = $db->selectSingleRow('tboxen', 'cTitel', 'Trusted Shops - Rating');
        $ts_check_box_vorlage = $db->selectSingleRow('tboxvorlage', 'cName', 'Trusted Shops - Rating');

        if (is_object($ts_check_box))
            $oTSFeature_Box->delete($ts_check_box->kBox);
        /**/

        $queryResult = $db->updateRow("xplugin_lfs_ts_features_config", "ts_id", $ts_id_edit->ts_id, $ts_id_edit);

        if ($queryResult >= 0) {
            $smarty->assign('ts_message', __('Die Konfiguration wurde gespeichert!'));
            $smarty->assign('ts_message_class', 'box_success alert alert-success');
        } else {
            $smarty->assign('ts_message', __('Es trat ein Fehler auf - Konfiguration konnte nicht gespeichert werden!'));
            $smarty->assign('ts_message_class', 'box_error alert alert-danger');
        }
        /**/
    }
}

if (isset($_GET['ts_add_error']) && (int)$_GET['ts_add_error'] == 1) {
    $smarty->assign('ts_message', __('Es trat ein Fehler auf - ID ist bereits installiert oder es wurde keine Shop-Sprache ausgewählt!'));
    $smarty->assign('ts_message_class', 'box_error alert alert-danger');
}

$sql = "SELECT tsprache.cNameDeutsch,xplugin_lfs_ts_features_config.*
          FROM xplugin_lfs_ts_features_config
          LEFT JOIN tsprache ON tsprache.kSprache = xplugin_lfs_ts_features_config.ts_sprache";
$ts_id_all_arr = $db->executeQuery($sql, 2);

$sql = "SELECT * FROM tsprache WHERE kSprache NOT IN (SELECT ts_sprache FROM xplugin_lfs_ts_features_config)";
$ts_id_sprache_free_arr = $db->executeQuery($sql, 2);

$smarty->assign('ts_css_class', "ts_shop4");

$smarty->assign('ts_id_shopsprachen_free', $ts_id_sprache_free_arr);
$smarty->assign('ts_id_all_arr', $ts_id_all_arr);
$smarty->assign('ts_id_add_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Erweiterte%20Konfiguration');
$smarty->assign('ts_id_edit_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Erweiterte%20Konfiguration');
$smarty->assign('ts_id_delete_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Konfiguration');
$smarty->assign('ts_id_cancel_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Konfiguration');
$smarty->assign('ts_id_save_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Erweiterte%20Konfiguration');
$smarty->assign('ts_id_save2_form_action', 'plugin.php?kPlugin=' . $oPlugin->getID() . '&cPluginTab=Konfiguration');
$smarty->assign("URL_ADMINMENU", $oPlugin->getPaths()->getAdminURL());

$smarty->display($oPlugin->getPaths()->getAdminPath() . "template/lfs_ts_features_config1.tpl");